unit umaingoprojson;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    BuTestMe: TButton;
    MemoDest: TMemo;
    memoSrc: TMemo;
    procedure BuTestMeClick(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  fpjson
  , jsonparser
  , LazLogger
  , TypInfo
  ;


{ TForm1 }

procedure TForm1.BuTestMeClick(Sender: TObject);
var
  hstr,s, objekt_name, objekt_type, field_name, field_value: string;
  jData, jItem, jItemj: TJSONData;
  jObject: TJSONObject;
  i,j: integer;
begin
  // Ist was zu tun ?
  hstr:= memoSrc.Text;
  //DebugLn(hstr);
  jData:= GetJSON(hstr);
  s:= jData.FormatJSON;
  MemoDest.Append(s);
  for i := 0 to jData.Count-1 do begin
    DebugLn('--- Loop = ' +i.ToString + '-----');
    jItem:= jData.Items[i];
    objekt_name:= TJSONObject(jData).Names[i];
    objekt_type:= GetEnumName(TypeInfo(TJSONtype), ord(jItem.JSONType));
    MemoDest.Append(objekt_name + ' -> '+jItem.Count.ToString + ' = ' + objekt_type);
    if SameStr('media',objekt_name) then begin
      for j:= 0 to jItem.Count-1 do begin
        jItemj:= jItem.Items[j];
        if jItem.JSONType = jtObject then
          objekt_name:= TJSONObject(jItem).Names[j]
        else
          objekt_name:= '-arr-';
        objekt_type:= GetEnumName(TypeInfo(TJSONtype), ord(jItemj.JSONType));
        MemoDest.Append(objekt_name + ' -> '+jItemj.Count.ToString + ' = ' + objekt_type);
        //field_name:= TJSONObject(jItem).Names[j];
        //field_value:= jItem.FindPath(field_name).AsString;
        //DebugLn(field_name + ' - '+ field_value );
      end;
    end;
  end;
end;

end.

